package ink.wgink.mongo.login.service.impl;

import ink.wgink.common.base.DefaultBaseService;
import ink.wgink.interfaces.department.IDepartmentUserBaseService;
import ink.wgink.interfaces.group.IGroupUserBaseService;
import ink.wgink.interfaces.login.mongo.IMongoLoginService;
import ink.wgink.interfaces.position.IPositionUserBaseService;
import ink.wgink.interfaces.role.IRoleMenuBaseService;
import ink.wgink.interfaces.role.IRolePermissionBaseService;
import ink.wgink.interfaces.role.IRoleUserBaseService;
import ink.wgink.pojo.pos.user.mongo.MongoUserPO;
import ink.wgink.service.user.pojo.pos.UserPO;
import ink.wgink.service.user.service.IUserService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @ClassName: MongoLoginServiceImpl
 * @Description: mongo登录
 * @Author: wanggeng
 * @Date: 2022/5/19 11:31
 * @Version: 1.0
 */
@Service
public class MongoLoginServiceImpl extends DefaultBaseService implements IMongoLoginService {

    private static final String COLLECTION_NAME = "loginUser";
    @Autowired
    private MongoTemplate mongoTemplate;
    @Autowired
    private IUserService userService;
    @Autowired(required = false)
    private IDepartmentUserBaseService departmentUserBaseService;
    @Autowired(required = false)
    private IRoleUserBaseService roleUserBaseService;
    @Autowired(required = false)
    private IRoleMenuBaseService roleMenuBaseService;
    @Autowired(required = false)
    private IRolePermissionBaseService rolePermissionService;
    @Autowired(required = false)
    private IGroupUserBaseService groupUserBaseService;
    @Autowired(required = false)
    private IPositionUserBaseService positionUserBaseService;

    @Override
    public void update(String userId) {
        UserPO userPO = userService.getPO(userId);
        MongoUserPO mongoUserPO = new MongoUserPO();
        BeanUtils.copyProperties(userPO, mongoUserPO);



    }

    @Override
    public void delete(List<String> userIds) {

    }

    @Override
    public MongoUserPO getPO(String userId) {
        return mongoTemplate.findOne(new Query().addCriteria(Criteria.where("userId").is(userId)), MongoUserPO.class, COLLECTION_NAME);
    }

    @Override
    public MongoUserPO getPOByUsername(String username) {
        return mongoTemplate.findOne(new Query().addCriteria(Criteria.where("userUsername").is(username)), MongoUserPO.class, COLLECTION_NAME);
    }

}
